import "DigitalUtopia.DUInterface";
import "DigitalUtopia.Utilsx";
import "Turbine.UI";
import "Turbine.UI.Lotro";
import "Turbine.Gameplay";
import "DigitalUtopia.Utilsx.Class";

MainBar = class( Turbine.UI.Window );

function MainBar:Constructor(side)
	Turbine.UI.Window.Constructor( self );
	--self:SetBackColor(Turbine.UI.Color(.1,0,0,0));
	
	self.side = side;
	self.defaultColor={r=1,g=1,b=1};
	self.textDisplayType=3;
	self.color1={pct=0.50,r=255,g=255,b=0};
	self.color2={pct=0.25,r=255,g=0,b=0};
	self:SetSize(350,300);
	self:SetMouseVisible(false);
	self.enableBlending=false;
	self.enableTwoColor=false;
	self.enableEffects=false
	self.textWindow = Turbine.UI.Control();
	self.textWindow:SetSize(350,300);
	self.textWindow:SetParent(self);
	self.textWindow:SetMouseVisible(false);
	self.textWindow:SetZOrder(99);
	self.textWindow:SetBackColor(Turbine.UI.Color(.01,0,0,0));
	self.textWindow:SetBackColorBlendMode(2);
	self.textWindow:SetBlendMode(2);
	self.contWindow = Turbine.UI.Window();
	self.contWindow:SetSize(350,300);
	self.contWindow:SetParent(self);
	self.contWindow:SetMouseVisible(false);
	self.contWindow:SetZOrder(0);
	self.fill = Turbine.UI.Window();
	self.fill:SetSize(65,190);
	self.fill:SetPosition(143,55);
	self.fill:SetParent(self.contWindow);
	self.fill:SetMouseVisible(false);
	self.border = Turbine.UI.Control();
	self.border:SetParent(self.fill);
	self.border:SetSize(65,190);
	self.border:SetBlendMode(4);
	self.border:SetMouseVisible(false);
	self.border:SetZOrder(20);
	self.bg = Turbine.UI.Control();
	self.bg:SetParent(self.fill);
	self.bg:SetSize(65,0);
	self.bg:SetBlendMode(0);
	self.bg:SetMouseVisible(false);
	self.bg:SetZOrder(30);

	self.overlay = Turbine.UI.Control();
	self.overlay:SetSize(60,190);
	self.overlay:SetPosition(0,0);
	self.overlay:SetParent(self.fill);
	self.overlay:SetBackColor(Turbine.UI.Color(1,1,0,0));
	self.overlay:SetZOrder(0);
	self.overlay:SetBackColorBlendMode(5);
	self.overlay:SetMouseVisible(false);
	self.label=Turbine.UI.Label();
	self.label:SetParent(self.textWindow);
	self.label:SetPosition(0,0);
	self.label:SetForeColor(Turbine.UI.Color(1,0,1,0));
	self.label:SetBackColor(Turbine.UI.Color(.01,0,0,0));
	self.label:SetZOrder(99);
	self.label:SetBackColorBlendMode(4);
	self.label:SetBlendMode(4);
	self.label:SetSize(200,30);
	self.label:SetMouseVisible(false);
	self.label:SetFontStyle( Turbine.UI.FontStyle.Outline );
	self.label:SetOutlineColor( Turbine.UI.Color( 1,0, 0, 0 ) );
	self.label:SetFont(Turbine.UI.Lotro.Font.TrajanProBold16);
	self.label:SetText("100%\n999,999/999,999 ");
	

	self.overlay.MouseClick=function(sender,args)
		self.border:SetBlendMode( ( self.border:GetBlendMode() + 1 ) % 9 );
	end
	
	if (self.side==0)then
		self.bg:SetBackground("DigitalUtopia/Palantir/Resources/bg3.tga");
		self.fill:SetBackground("DigitalUtopia/Palantir/Resources/inner.tga");
		self.border:SetBackground("DigitalUtopia/Palantir/Resources/border.tga");
		self.label:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter);
		self.label:SetPosition(60,130);
	else
		self.bg:SetBackground("DigitalUtopia/Palantir/Resources/bg4.tga");
		self.fill:SetBackground("DigitalUtopia/Palantir/Resources/innerb.tga");
		self.border:SetBackground("DigitalUtopia/Palantir/Resources/borderb.tga");
		self.label:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter);
		self.label:SetPosition(95,130);
	end
	
	self.SetDisplay=function(cur,maxx)
		
		self.dif = (maxx-cur)/maxx;
		self.bg:SetSize(65,self.dif*190);
		self.pct = (1-(self.dif));
	--Turbine.Shell.WriteLine(self.pct);
		self.SetValText(cur,maxx); 
			if(self.enableEffects==true)then
				if (self.enableBlending == true and self.enableTwoColor==true)then
					if (self.color1.pct > self.color2.pct)then
						if (self.pct >= self.color1.pct)then
							self.colorValPct=(1-(self.pct - self.color1.pct) /(1-self.color1.pct));
							self.newColorR=((self.color1.r-self.defaultColor.r)*self.colorValPct)+self.defaultColor.r;
							
							self.newColorG=((self.color1.g - self.defaultColor.g)*self.colorValPct)+self.defaultColor.g;
							self.newColorB=((self.color1.b - self.defaultColor.b)*self.colorValPct)+self.defaultColor.b;
							self.SetColor(self.newColorR,self.newColorG,self.newColorB);
						elseif (self.pct < self.color1.pct)then
							if (self.pct > self.color2.pct)then
								self.colorValPct=(1-(self.pct - self.color2.pct)/(self.color1.pct - self.color2.pct));
								self.newColorR=((self.color2.r-self.color1.r)*self.colorValPct)+self.color1.r;
								self.newColorG=((self.color2.g-self.color1.g)*self.colorValPct)+self.color1.g;
								self.newColorB=((self.color2.b-self.color1.b)*self.colorValPct)+self.color1.b;
								self.SetColor(self.newColorR,self.newColorG,self.newColorB);
							else
								self.SetColor(self.color2.r,self.color2.g,self.color2.b);
							end
						end
					else
						--if color2.pct > self.color1.pct
						if (self.pct >= self.color2.pct)then
						self.colorValPct=1-(self.pct - self.color2.pct) /(1-self.color2.pct);
						self.newColorR=((self.color2.r-self.defaultColor.r)*self.colorValPct)+self.defaultColor.r;
						self.newColorG=((self.color2.g - self.defaultColor.g)*self.colorValPct)+self.defaultColor.g;
						self.newColorB=((self.color2.b - self.defaultColor.b)*self.colorValPct)+self.defaultColor.b;
						self.SetColor(self.newColorR,self.newColorG,self.newColorB);
						elseif (self.pct < self.color2.pct)then
							if (self.pct > self.color1.pct)then
								self.colorValPct=(1-(self.pct - self.color1.pct)/(self.color2.pct - self.color1.pct));
								self.newColorR=((self.color1.r-self.color2.r)*self.colorValPct)+self.color2.r;
								self.newColorG=((self.color1.g-self.color2.g)*self.colorValPct)+self.color2.g;
								self.newColorB=((self.color1.b-self.color2.b)*self.colorValPct)+self.color2.b;
								self.SetColor(self.newColorR,self.newColorG,self.newColorB);
							else
								self.SetColor(self.color1.r,self.color1.g,self.color1.b);
							end
						end
					end
				elseif(self.enableTwoColor==false and self.enableBlending==true)then
				
					if (self.pct >= self.color1.pct)then
							self.colorValPct=1-(self.pct - self.color2.pct) /(1-self.color2.pct);
							self.newColorR=((self.color1.r-self.defaultColor.r)*self.colorValPct)+self.defaultColor.r;
							self.newColorG=((self.color1.g - self.defaultColor.g)*self.colorValPct)+self.defaultColor.g;
							self.newColorB=((self.color1.b - self.defaultColor.b)*self.colorValPct)+self.defaultColor.b;
							self.SetColor(self.newColorR,self.newColorG,self.newColorB);
					else
							self.SetColor(self.color1.r,self.color1.g,self.color1.b);
					end		
				elseif(self.enableTwoColor==false and self.enableBlending==false)then
					if (self.pct >= self.color1.pct)then
						self.SetColor(self.defaultColor.r,self.defaultColor.g,self.defaultColor.b);
					else
						self.SetColor(self.color1.r,self.color1.g,self.color1.b);
					end
				else
					if (self.color1.pct > self.color2.pct)then
						if (self.pct > self.color1.pct)then
							self.SetColor(self.defaultColor.r,self.defaultColor.g,self.defaultColor.b);
						elseif (self.pct <= self.color1.pct)then
							if (self.pct > self.color2.pct)then
								self.SetColor(self.color1.r,self.color1.g,self.color1.b);
							else
								self.SetColor(self.color2.r,self.color2.g,self.color2.b);
							end
						end
					else
						--if color2.pct > self.color1.pct
						if (self.pct > self.color2.pct)then
							self.SetColor(self.defaultColor.r,self.defaultColor.g,self.defaultColor.b);
						elseif (self.pct <= self.color2.pct)then
							if (self.pct > self.color1.pct)then
								self.SetColor(self.color2.r,self.color2.g,self.color2.b);
							else
								self.SetColor(self.color1.r,self.color1.g,self.color1.b);
							end
						end
					end
				end
			end
	end
	
	self.SetColor=function(r,g,b)

		self.color = Turbine.UI.Color((r/255),(g/255),(b/255))
		self.overlay:SetBackColor(self.color);
	end
	
	
	
	self.SetValText=function(cur,maxx)
		if (self.textDisplayType==1)then
			self.label:SetText((math.floor((100-(((maxx-cur)/maxx)*100))+0.5)).."%");
		elseif (self.textDisplayType==2)then
			self.label:SetText(math.floor(cur+.5))
		elseif (self.textDisplayType==3)then
			self.label:SetText(math.floor(cur+.5).."/"..maxx);
		else
			self.label:SetText((math.floor((100-(((maxx-cur)/maxx)*100))+0.5)).."%\n"..math.floor(cur+.5).."/"..maxx);
		end
	end
	
	self.SetGfxOpacity=function(op)
		self.fill:SetOpacity(op);
	end
	
	self.SetTextOpacity=function(op)
		self.label:SetForeColor(Turbine.UI.Color(op,0,1,0));
		if (op < .75)then
			self.label:SetOutlineColor(Turbine.UI.Color(op*(1-(.75-op)),0,0,0));
		else
			self.label:SetOutlineColor(Turbine.UI.Color(op,0,0,0));
		end
		
		
	end
	
	self.SetTextPosition=function(pos)
		if (self.side==0)then
			if (pos==Turbine.UI.ContentAlignment.TopRight)then
				self.label:SetTextAlignment(Turbine.UI.ContentAlignment.TopRight);
				self.label:SetPosition(-40,60);
			elseif (pos==Turbine.UI.ContentAlignment.TopCenter)then
				self.label:SetTextAlignment(Turbine.UI.ContentAlignment.BottomCenter);
				self.label:SetPosition(75,30);
			elseif (pos==Turbine.UI.ContentAlignment.TopLeft)then
				self.label:SetTextAlignment(Turbine.UI.ContentAlignment.TopLeft);
				self.label:SetPosition(205,60);
			elseif (pos==Turbine.UI.ContentAlignment.MiddleLeft)then
				self.label:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleLeft);
				self.label:SetPosition(175,130);
			elseif (pos==Turbine.UI.ContentAlignment.BottomLeft)then
				self.label:SetTextAlignment(Turbine.UI.ContentAlignment.BottomLeft);
				self.label:SetPosition(205,212);
			elseif (pos==Turbine.UI.ContentAlignment.BottomCenter)then
				self.label:SetTextAlignment(Turbine.UI.ContentAlignment.TopCenter);
				self.label:SetPosition(85,245);
			elseif (pos==Turbine.UI.ContentAlignment.BottomRight)then
				self.label:SetTextAlignment(Turbine.UI.ContentAlignment.BottomRight);
				self.label:SetPosition(-30,212);
			elseif (pos==Turbine.UI.ContentAlignment.MiddleRight)then
				self.label:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleRight);
				self.label:SetPosition(-55,130);
			end
		else
			if (pos==Turbine.UI.ContentAlignment.TopRight)then
				self.label:SetTextAlignment(Turbine.UI.ContentAlignment.TopLeft);
				self.label:SetPosition(190,60);
			elseif (pos==Turbine.UI.ContentAlignment.TopCenter)then
				self.label:SetTextAlignment(Turbine.UI.ContentAlignment.BottomCenter);
				self.label:SetPosition(75,30);
			elseif (pos==Turbine.UI.ContentAlignment.TopLeft)then
				self.label:SetTextAlignment(Turbine.UI.ContentAlignment.TopRight);
				self.label:SetPosition(-55,60);
			elseif (pos==Turbine.UI.ContentAlignment.MiddleLeft)then
				self.label:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleRight);
				self.label:SetPosition(-20,130);
			elseif (pos==Turbine.UI.ContentAlignment.BottomLeft)then
				self.label:SetTextAlignment(Turbine.UI.ContentAlignment.BottomRight);
				self.label:SetPosition(-60,212);
			elseif (pos==Turbine.UI.ContentAlignment.BottomCenter)then
				self.label:SetTextAlignment(Turbine.UI.ContentAlignment.TopCenter);
				self.label:SetPosition(67,245);
			elseif (pos==Turbine.UI.ContentAlignment.BottomRight)then
				self.label:SetTextAlignment(Turbine.UI.ContentAlignment.BottomLeft);
				self.label:SetPosition(180,212);
			elseif (pos==Turbine.UI.ContentAlignment.MiddleRight)then
				self.label:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleLeft);
				self.label:SetPosition(210,130);
			end
		end
	end
end